buildgcc: Remove all bashisms, making the script run also on BSD
[coreboot.git] / util / crossgcc / buildgcc
index 83b7cdff4ec8ecd5cd1d5f0731246657e0ca9f52..5591810e57c16ebf1382ce0f149b3347d619d634 100755 (executable)
@@ -1,9 +1,11 @@
-#!/bin/bash
+#!/bin/sh
 #
 # Copyright (C) 2008-2010 by coresystems GmbH
 # written by Patrick Georgi <patrick.georgi@coresystems.de> and
 #            Stefan Reinauer <stefan.reinauer@coresystems.de>
 #
+# Copyright (C) 2011 by Sage Electronic Engineering
+#
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation; version 2 of the License.
@@ -18,8 +20,8 @@
 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 #
 
-CROSSGCC_DATE="December 16th, 2010"
-CROSSGCC_VERSION="1.03"
+CROSSGCC_DATE="August 8th, 2011"
+CROSSGCC_VERSION="1.04"
 
 # default settings
 TARGETDIR=`pwd`/xgcc
@@ -37,6 +39,7 @@ GDB_VERSION=7.2
 W32API_VERSION=3.17-2
 W32API_VERSION_SHORT=3.17
 MINGWRT_VERSION=3.18
+IASL_VERSION=20110623
 
 # archive locations
 GMP_ARCHIVE="ftp://ftp.gmplib.org/pub/gmp-${GMP_VERSION}/gmp-${GMP_VERSION}.tar.bz2"
@@ -48,6 +51,7 @@ BINUTILS_ARCHIVE="http://ftp.gnu.org/gnu/binutils/binutils-${BINUTILS_VERSION}.t
 GDB_ARCHIVE="http://ftp.gnu.org/gnu/gdb/gdb-${GDB_VERSION}.tar.bz2"
 W32API_ARCHIVE="http://downloads.sourceforge.net/project/mingw/MinGW/BaseSystem/RuntimeLibrary/Win32-API/w32api-${W32API_VERSION_SHORT}/w32api-${W32API_VERSION}-mingw32-src.tar.lzma"
 MINGWRT_ARCHIVE="http://downloads.sourceforge.net/project/mingw/MinGW/BaseSystem/RuntimeLibrary/MinGW-RT/mingwrt-${MINGWRT_VERSION}/mingwrt-${MINGWRT_VERSION}-mingw32-src.tar.gz"
+IASL_ARCHIVE="http://www.acpica.org/download/acpica-unix-${IASL_VERSION}.tar.gz"
 
 GMP_DIR="gmp-${GMP_VERSION}"
 MPFR_DIR="mpfr-${MPFR_VERSION}"
@@ -58,6 +62,7 @@ BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
 GDB_DIR="gdb-${GDB_VERSION}"
 W32API_DIR="w32api-${W32API_VERSION}-mingw32"
 MINGWRT_DIR="mingwrt-${MINGWRT_VERSION}-mingw32"
+IASL_DIR="acpica-unix-${IASL_VERSION}"
 
 SAVETEMPS=0
 SKIPGDB=0
@@ -96,7 +101,7 @@ MAKE=`searchgnu make` || exit $?
 cleanup()
 {
        printf "Cleaning up temporary files... "
-       rm -rf build-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-* gdb-* w32api-* mingwrt-*
+       rm -rf build-* combined gcc-* gmp-* mpfr-* mpc-* libelf-* binutils-* gdb-* w32api-* mingwrt-* acpica-*
        printf "${green}ok${NC}\n"
 }
 
@@ -127,6 +132,7 @@ myversion()
 
        cat << EOF
 Copyright (C) 2008-2010 by coresystems GmbH
+Copyright (C) 2011 by Sage Electronic Engineering
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -147,8 +153,8 @@ export PATH=$PATH:.
 getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
 
 # parse parameters.. try to find out whether we're running GNU getopt
-getoptbrand="`getopt -V`"
-if [ "${getoptbrand:0:6}" == "getopt" ]; then
+getoptbrand="`getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,'`"
+if [ "${getoptbrand}" = "getopt" ]; then
        # Detected GNU getopt that supports long options.
        args=`getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb Vhcd:p:j:D:tG -- "$@"`
        eval set "$args"
@@ -191,14 +197,14 @@ if [ "$TARGETARCH" = "i386-mingw32" ]; then
        MINGW_ARCHIVES="$W32API_ARCHIVE $MINGWRT_ARCHIVE"
 fi
 
-if [ ${GCC_VERSION} == "4.5.0" -o ${GCC_VERSION} == "4.6.0" ]; then
+if [ ${GCC_VERSION} = "4.5.0" -o ${GCC_VERSION} = "4.6.0" ]; then
   # coreboot does not like the GOLD linker
   # USE_GOLD="--enable-gold"
   USE_GOLD=""
   GCC_OPTIONS="--enable-lto"
 fi
 
-if [ ${GCC_VERSION} == "4.6.0" ]; then
+if [ ${GCC_VERSION} = "4.6.0" ]; then
   if [ ! -r tarballs/gcc-core-${GCC_VERSION}.tar.bz2 ]; then
     printf "Pre-Release GCC ${GCC_VERSION}, checking out subversion trunk\n"
     mkdir -p tarballs/.tmp
@@ -217,7 +223,7 @@ fi
 
 printf "Downloading tar balls ... \n"
 mkdir -p tarballs
-for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $MINGW_ARCHIVES; do
+for ARCHIVE in $GMP_ARCHIVE $MPFR_ARCHIVE $MPC_ARCHIVE $LIBELF_ARCHIVE $GCC_ARCHIVE $BINUTILS_ARCHIVE $GDB_ARCHIVE $MINGW_ARCHIVES $IASL_ARCHIVE; do
        FILE=`basename $ARCHIVE`
        printf " * $FILE "
        test -f tarballs/$FILE && printf "(cached)" || (
@@ -238,18 +244,20 @@ if [ "$TARGETARCH" = "i386-mingw32" ]; then
 fi
 
 printf "Unpacking and patching ... \n"
-for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $GDB_PACKAGE $MINGW_PACKAGES; do
+for PACKAGE in GMP MPFR MPC LIBELF GCC BINUTILS $GDB_PACKAGE $MINGW_PACKAGES IASL; do
        archive=$PACKAGE"_ARCHIVE"
-       archive=${!archive}
+       archive="`eval echo '$'$archive`"
        dir=$PACKAGE"_DIR"
-       test -d ${!dir} || (
+       dir="`eval echo '$'${dir}`"
+       test -d ${dir} || (
                printf " * `basename $archive`\n"
                FLAGS=zxf
-               test ${archive:${#archive}-2:2} = "gz" && FLAGS=zxf
-               test ${archive:${#archive}-3:3} = "bz2" && FLAGS=jxf
-               test ${archive:${#archive}-4:4} = "lzma" && FLAGS="--lzma -xf"
+               suffix=`echo $archive | sed 's,.*\.,,'`
+               test "$suffix" = "gz" && FLAGS=zxf
+               test "$suffix" = "bz2" && FLAGS=jxf
+               test "$suffix" = "lzma" && FLAGS="--lzma -xf"
                $TAR $FLAGS tarballs/`basename $archive`
-               for patch in patches/${!dir}_*.patch; do
+               for patch in patches/${dir}_*.patch; do
                        test -r $patch || continue
                        printf "   o `basename $patch`\n"
                        $PATCH -s -N -p0 < `echo $patch`
@@ -302,7 +310,7 @@ printf "Building GMP ${GMP_VERSION} ... "
        $MAKE $JOBS || touch .failed
        $MAKE install DESTDIR=$DESTDIR || touch .failed
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-gmp/crossgcc-build.log
+) > build-gmp/crossgcc-build.log 2>&1
 test -r build-gmp/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-gmp/.failed && exit 1
 fi
@@ -335,7 +343,7 @@ printf "Building MPFR ${MPFR_VERSION} ... "
        fi
 
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-mpfr/crossgcc-build.log
+) > build-mpfr/crossgcc-build.log 2>&1
 test -r build-mpfr/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-mpfr/.failed && exit 1
 fi
@@ -355,7 +363,7 @@ printf "Building MPC ${MPC_VERSION} ... "
        $MAKE install DESTDIR=$DESTDIR || touch .failed
 
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-mpc/crossgcc-build.log
+) > build-mpc/crossgcc-build.log 2>&1
 test -r build-mpc/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-mpc/.failed && exit 1
 fi
@@ -374,7 +382,7 @@ printf "Building libelf ${LIBELF_VERSION} ... "
        $MAKE install DESTDIR=$DESTDIR || touch .failed
 
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-libelf/crossgcc-build.log
+) > build-libelf/crossgcc-build.log 2>&1
 test -r build-libelf/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-libelf/.failed && exit 1
 fi
@@ -392,7 +400,7 @@ printf "Building binutils ${BINUTILS_VERSION} ... "
        $MAKE $JOBS || touch .failed
        $MAKE install DESTDIR=$DESTDIR || touch .failed
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-binutils/crossgcc-build.log
+) > build-binutils/crossgcc-build.log 2>&1
 test -r build-binutils/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-binutils/.failed && exit 1
 fi
@@ -410,7 +418,7 @@ printf "Building GCC ${GCC_VERSION} ... "
        # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
        # but it does not seem to work properly. At least the host library
        # libiberty is not compiled with CFLAGS_FOR_BUILD.
-       CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
+       CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" CFLAGS_FOR_BUILD="$HOSTCFLAGS" `readlink -f ../gcc-${GCC_VERSION}/configure` \
                --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
                --target=${TARGETARCH} --disable-werror --disable-shared \
                --disable-libssp --disable-bootstrap --disable-nls \
@@ -422,7 +430,7 @@ printf "Building GCC ${GCC_VERSION} ... "
        $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" || touch .failed
        $MAKE install DESTDIR=$DESTDIR || touch .failed
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-gcc/crossgcc-build.log
+) > build-gcc/crossgcc-build.log 2>&1
 test -r build-gcc/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-gcc/.failed && exit 1
 fi
@@ -442,11 +450,29 @@ printf "Building GDB ${GDB_VERSION} ... "
        $MAKE $JOBS || touch .failed
        $MAKE install DESTDIR=$DESTDIR || touch .failed
        if [ ! -f .failed ]; then touch .success; fi
-) &> build-gdb/crossgcc-build.log
+) > build-gdb/crossgcc-build.log 2>&1
 test -r build-gdb/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
 test -r build-gdb/.failed && exit 1
 fi
 
+if [ -f $IASL_DIR/compiler/.success ]; then
+       printf "Skipping IASL as it is already built\n"
+else
+printf "Building IASL ${IASL_VERSION} ... "
+(
+       cd $IASL_DIR/compiler
+       export PATH=$PATH:$DESTDIR$TARGETDIR/bin
+       rm -f .failed
+       CFLAGS="$HOSTCFLAGS"
+       $MAKE || touch .failed
+       rm -f $DESTDIR$TARGETDIR/bin/iasl || touch .failed
+       cp iasl $DESTDIR$TARGETDIR/bin || touch .failed
+       if [ ! -f .failed ]; then touch .success; fi
+) > $IASL_DIR/compiler/crossgcc-build.log 2>&1
+test -r $IASL_DIR/compiler/.failed && printf "${RED}failed${NC}\n" || printf "${green}ok${NC}\n"
+test -r $IASL_DIR/compiler/.failed && exit 1
+fi
+
 if [ $SAVETEMPS -eq 0 ]; then
        printf "Cleaning up... "
        rm -rf ${GMP_DIR} build-gmp
@@ -456,6 +482,7 @@ if [ $SAVETEMPS -eq 0 ]; then
        rm -rf ${BINUTILS_DIR} build-binutils
        rm -rf ${GCC_DIR} build-gcc
        rm -rf ${GDB_DIR} build-gdb
+       rm -rf ${IASL_DIR}
        printf "${green}ok${NC}\n"
 else
        printf "Leaving temporary files around... ${green}ok${NC}\n"